Page MenuHome

Improve Palette management in Paint Modes (Meshes and Grease Pencil)
Confirmed, NormalPublicDESIGN

Assigned To
None
Authored By
Antonio Vazquez (antoniov)
Nov 20 2019, 5:05 PM
Tokens
"Love" token, awarded by rombout."Love" token, awarded by ofuscado."Love" token, awarded by CMC."Love" token, awarded by andreasus."100" token, awarded by Frozen_Death_Knight."Love" token, awarded by 3Rton."Love" token, awarded by Zino."Love" token, awarded by amonpaike."Love" token, awarded by HooglyBoogly.

Description

This is not a task only related to Grease Pencil, but also to any Paint mode.

As part of the Vertex Paint development in Grease Pencil, we have detected some missing features in Palettes and we have decided to fix it, because Palettes look a little outdate and without improvements for several versions.

Missing features/ WishList:

  • There is no default palette.
  • Swatches cannot be re-arranged
  • Colors cannot be sorted
  • Colors can't be named
  • Palettes cannot be merged
  • templatePalette control UI is outdated
  • No ability to import palettes from other software
  • No ability to export palettes to other software
  • Missing easy way to create palettes from images

About default palette, in grease pencil we have implemented a default palette similar to Krita/GImp palette. This palette is required by GPencil, but it would be good idea to set this default palette in Texture Paint and Vertex Paint for meshes too.

Currently, I have solved the Sorting, Moving, Join and some Import modules in Grease Pencil branch, but the list above is the initial ideas.

Event Timeline

Antonio Vazquez (antoniov) updated the task description. (Show Details)

Example of moving colors:

Example creating a Palette from Image:

Example of default palette defined in grease pencil branch (equals to Krita default).

Example of Photoshop default palette imported using new addon of T71548

The palette list does not follow the UI of other lists in Blender, and with new operators we will need more buttons and menus:

That right side looks quite a bit better, I agree.

Small thing but it would also be cool if "Extract Palette" used the same name as the image for the palette.

Example of moving colors

I really would prefer if we can solve this with drag and drop, rather than adding more Up/Down arrow buttons. Not only is it unsightly and ungainly, it's also impractical if you want to move a color swatch 40 places up, you'd have to click that button 40 times!

@Julian Eisel (Severin) Is this another thing that could be handled by your drag and drop system?

@Julian Eisel (Severin) Is this another thing that could be handled by your drag and drop system?

It will not be handled by D4071, but should be once we extend it for T67893: Drag and Drop for UI elements.

Example of moving colors

I really would prefer if we can solve this with drag and drop, rather than adding more Up/Down arrow buttons. Not only is it unsightly and ungainly, it's also impractical if you want to move a color swatch 40 places up, you'd have to click that button 40 times!

@Julian Eisel (Severin) Is this another thing that could be handled by your drag and drop system?

this yes! so much i absolutly hate this up/down arrow design +1 to your idea

Example of moving colors

I really would prefer if we can solve this with drag and drop, rather than adding more Up/Down arrow buttons. Not only is it unsightly and ungainly, it's also impractical if you want to move a color swatch 40 places up, you'd have to click that button 40 times!

@Julian Eisel (Severin) Is this another thing that could be handled by your drag and drop system?

Totally agree, but this is somewhat more general for all list controls in Blender. It's not the main topic of this task, we can implement it when drag and drop to rearrange list items is ready

Antonio Vazquez (antoniov) renamed this task from Improve Palette management to Improve Palette management in Paint Modes (Meshes and Grease Pencil).Nov 24 2019, 11:47 AM
Antonio Vazquez (antoniov) updated the task description. (Show Details)
Antonio Vazquez (antoniov) edited a custom field.

Great to see palettes getting some care.
From the python API perspective, I would like also to use palettes generally, (specifically with materials/shader editor), but any kind of flexibility would be useful.
At the moment, I had trouble getting a custom palette property to behave, it seems template_palette is limited in scope and not much is exposed within the API and locked down to update parts in the UI it only knows about.
I wouldn't know where to start since Palette and specifically how PaletteColor behaves is quite unique CTRL-click to change, click to update the color picker; but currently only the color picker it knows about.
But since Palette.colors is a collection property itself, perhaps a new template?

template_palette_colors(myproperty.active_palette, "colors", myproperty, "picker_color")

Not to mention the required operators (new, remove, etc)

Just some thoughts. Thanks again.

I don't know if it is possible. But it could be interesting to keep space to be able to display it as an horizontal ribbon.


I imagine that by pressing Tab with mouse pointer over tool settings bar, this bar would display a ribbon of colors instead of brush settings.

Such behavior would be as useful for a weight paint palette.

An additional idea:
I remember in another render engine (older version of Appleseed I believe) we were able to define colors, like global colors that can be re-used in shaders.
If we could re-use the colors of a color palette for shaders then we could also just change the color palette to change the colors of all shaders in one go. To get an idea, check: https://youtu.be/DkznarCvPEQ?t=33

JPG (joules) added a comment.EditedNov 27 2019, 4:22 AM

An additional idea:
I remember in another render engine (older version of Appleseed I believe) we were able to define colors, like global colors that can be re-used in shaders.
If we could re-use the colors of a color palette for shaders then we could also just change the color palette to change the colors of all shaders in one go. To get an idea, check: https://youtu.be/DkznarCvPEQ?t=33

Yes, currently my addon injects a custom RGB node (named/identifier is unique) into a shader which allows easy access to coloring outside of the shader and to experiment with visual ideas. However palettes at this stage are limited in scope as I mentioned and was only able to resort to this solution which is far from optimal.

JPG (joules) rescinded a token.
Antonio Vazquez (antoniov) changed the status of subtask T71548: Import Krita/Gimp and ASE palettes from Unknown Status to Resolved.Dec 2 2019, 10:40 AM

Ive added more sorting methods which i believe work better. Also added CSS and fixed KPL and ASE import. Its almost done, i couldn't get it all working for the release though. Im still working on a function which can also restore the order if the user doesn't like the result of the sorting.

@Rombout Versluijs (rombout) This is great! When you hav ethe code ready, please upload a patch for review.

@Antonio Vazquez (antoniov) ive looked a bit into how to work with that. I haven't found a method to only make a patch for single addons. Is it correct i need to fork all of them? I normally use github for this kind of stuff. I know nothing about the other. Ill try my best to figure out everything.

Currenlty menu looks like this. I would also like to see if i can get the export working. That would be nice if one need to paint in a different application and also want to use the same palette.

@Rombout Versluijs (rombout) You can do a ptach following these steps:

  1. Create a branch based on master addon
  2. Apply your changes in this temp branch and commit
  3. using ARC: arc diff

if don't use ARC, you can create a patch manually (step 3):

  1. Change to master branch
  2. git diff master mybranch > c:/tmp/mypatch.diff
  3. Copy the diff to the patch screen: https://developer.blender.org/differential/diff/create/

Im on OSX, but what i don't fully understand is why do i need to fork or get the complete addon branch? Or am i not understanding it correct? SOrry for the fuzz

@Rombout Versluijs (rombout) To have a branch is to get your changes separated and be able to generate a diff patch. A branch in Git just use few bytes, it's not a copy.